<template>
    <v-container class="container mx-auto" v-if="lessons.length !== 0">
        <v-row class="mb-4" style="align-items: center">
            <v-spacer/>
            <task-edit is-add/>
            <v-btn v-if="isCurrentUserAllowed" outlined color="black" elevation="5" class="ml-1 mr-1"
                   @click.prevent="openEditor">
                {{ $t("LNG_LESSON_OPEN_EDITOR") }}
            </v-btn>
            <lesson-edit v-bind:is-add="false"/>
            <lesson-delete/>
            <v-tooltip v-if="isCurrentUserAllowed" bottom>
                <template v-slot:activator="{ on, attrs }">
                    <div v-on="on" v-bind="attrs" class="ml-1 mr-1">
                        <v-switch v-model="display"
                                  :label="display ? $t('LNG_SHOW_LESSON_HIDDEN') : $t('LNG_SHOW_LESSON_VISIBLE')"
                                  @click="setDisplay"/>
                    </div>
                </template>
                <span>{{ $t("LNG_SHOW_LESSON_TOOLTIP") }}</span>
            </v-tooltip>
        </v-row>

        <vue-easymde v-model="content"
                     ref="markdownEditor"
                     :configs="configs"
                     @initialized="updateEditor"
                     class="markdownReader"/>

    </v-container>
</template>

<script>
import { mapGetters } from "vuex";
import { SET_CURRENTLESSONID, SET_LESSONS } from "@/store/mutations.type";
import Services from "@/services/api";
import LessonEdit from '@/components/LessonEdit.component';
import LessonDelete from '@/components/LessonDelete.component';
import VueEasymde from "vue-easymde";
import TaskEdit from "@/components/TaskEdit.component";

export default {
    name: 'LessonReader',
    components: { TaskEdit, LessonDelete, LessonEdit, VueEasymde },
    data: () => ({
        display: false,
        content: null,
        configs: {
            toolbar: false,
            status: false,
            spellChecker: false,
            autosave: {
                enabled: false
            },
            previewImagesInEditor: true,
            shortcuts: {
                cleanBlock: null,
                drawImage: null,
                drawLink: null,
                toggleBlockquote: null,
                toggleBold: null,
                toggleCodeBlock: null,
                toggleFullScreen: null,
                toggleHeadingBigger: null,
                toggleHeadingSmaller: null,
                toggleItalic: null,
                toggleOrderedList: null,
                togglePreview: null,
                toggleSideBySide: null,
                toggleUnorderedList: null,
            }
        }
    }),
    computed: {
        ...mapGetters(['user', 'lessons', 'currentLessonId']),
        isCurrentUserAllowed() {
            return this.user && (this.user.type === 'TEACHER' || this.user.type === 'ADMIN');
        },
        easymde() {
            return this.$refs?.markdownEditor?.easymde;
        },
    },
    async created() {
        await this.setLesson();
        if (!this.currentLessonId || this.currentLessonId > this.lessons.length) {
            this.$store.commit(SET_CURRENTLESSONID, 0);
        }
    },
    watch: {
        '$route.params.id': async function (id) {
            await this.setLesson(id);
        },
        'currentLessonId': async function () {
            await this.updateEditor();
            if (this.isCurrentUserAllowed)
                this.display = this.lessons?.[this.currentLessonId]?.hide;
        },
        'lessons': async function () {
            if (this.content) {
                await this.updateEditor();
                if (this.isCurrentUserAllowed)
                    this.display = this.lessons?.[this.currentLessonId]?.hide;
            }
        },
    },
    methods: {
        async setLesson(id) {
            if (!id)
                id = this.$route.params?.id;

            // get Lessons from a field after selecting one
            const lessons = await Services.Lesson.getLessonByField(id)
                .catch(() => {
                    this.$router.push({ name: "404 Not found" })
                });

            this.$store.commit(SET_LESSONS, lessons);
        },
        setDisplay() {
            this.lessons[this.currentLessonId].hide = this.display;
            Services.Lesson.patchLesson(this.lessons[this.currentLessonId]);
        },
        openEditor() {
            this.$router.push({
                name: 'LessonEditor',
                params: {
                    id: this.$route.params.id,
                    lessonId: this.lessons[this.currentLessonId].id
                }
            })
        },
        updateEditor() {
            this.easymde.codemirror.options.readOnly = true;
            let currentLesson = this.lessons[this.currentLessonId];
            if (currentLesson)
                this.content = this.fromJSONToMd(currentLesson);
            // TODO: find a better way
            setTimeout(async () => {
                if (!this.easymde.isPreviewActive())
                    this.easymde.togglePreview();
            }, 100);
        },
        fromJSONToMd({ title, paragraphs }) {
            let md = "";

            md += `# ${ title }\n`;
            paragraphs.forEach(({ title, titleSize, content }) => {
                md += ("#".repeat(titleSize) + " " + title + "\n");
                md += (content + "\n");
            })
            return md;
        },
    },
}
</script>

<style>
.markdownReader .EasyMDEContainer .CodeMirror {
    border: none !important;
}
.markdownReader img {
    width: 100%;
}
.markdownReader.vue-easymde .editor-preview-active,
.markdownReader.vue-easymde .editor-preview-active-side {
    /*display: contents !important;*/
}
</style>

<style lang="css" scoped>
@import '~easymde/dist/easymde.min.css';

.container {
    width: 80%;
}

.paragraph {
    border-left: 4px solid lightgrey;
    background-color: #f5f5f5;
}
</style>
